/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Officeセットアップクラス
//			変更履歴
//				2004.01.08	新規作成	五木田 泰史
//
package jp.co.ntt.lms.lo.Office;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.XMODate;
import jp.co.ntt.lms.xmo.util.*;

import java.util.Date;
import java.util.Hashtable;
import java.util.Vector;

/**
 * セットアップインタフェースクラス
 *
 * <PRE>
 *   OfficeLoの編集(登録・更新・削除・ユーザ登録・ユーザ削除)をする。
 *   上位にセットアップインタフェースクラスを持つ。
 * </PRE>
 *
 */
public class OfficeSetup extends Setup
	implements OfficeLoTable
{
	////////////////////////////////////////////////////////////////////////////
	// 抽象メソッドの実装
	////////////////////////////////////////////////////////////////////////////
	/**
	 * セットアップ登録処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupInsert(Hashtable htbParam)
			throws LOException
	{
		// 教材格納フォルダ名称を外部ID→RealLOIDに変える

		try {
			// パスの組み立て
			String strSessionID = (String)htbParam.get(SESSION_ID);		// SessionID
			String strRealLOID = (String)htbParam.get(REAL_LOID);		// RealLOID

			// DBに格納するファイル名を取得する
			// SPX-34の対応でDBのLOUrlフィールドにはファイル名のみを格納するように変更する。
			String strUploadFileName = (String)htbParam.get(UPLOAD_FILE_NAME);
			if( strUploadFileName != null){
				htbParam.put(LOURL, strUploadFileName);
			}

		} catch (Exception e){
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException( e.getMessage() );
		}

		// 個別テーブル登録処理
		OfficeLoDataAccess objDataAccess = new OfficeLoDataAccess();

		objDataAccess.insert( htbParam );

	}

	/**
	 * セットアップ更新処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupUpdate(Hashtable htbParam)
			throws LOException
	{
		OfficeLoDataAccess objDataAccess = new OfficeLoDataAccess();
		objDataAccess.update( htbParam );
	}

	/**
	 * セットアップ削除処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupDelete(Hashtable htbParam)
			throws LOException
	{
		OfficeLoDataAccess objDataAccess = new OfficeLoDataAccess();

		objDataAccess.delete( htbParam );
		try {
			String strRealLOID = (String)htbParam.get(LOID);				
			// パスの組み立て
			OfficeLoEnv objOfficeEnv = new OfficeLoEnv();
			// 教材格納フォルダ
			String strPath = objOfficeEnv.getMaterialPath() + "/" + (String)htbParam.get(LO_TYPE) + "/" + strRealLOID;
			// リソースの削除を行います。
			FileControl objFileControl= new FileControl();
			int intRet = objFileControl.delete(strPath);
		} catch (Exception e){
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException( e.getMessage() );
		}



	}

	/**
	 * セットアップユーザ登録処理
	 *
	 * @param htbParam パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupAddUser(Hashtable htbParam)
		throws LOException
	{
		// @pending ここに処理を記述します
	}


	/**
	 * セットアップユーザ削除処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected void setupDelUser(Hashtable htbParam)
		throws LOException
	{
		// @pending ここに処理を記述します
	}


	/**
	 * セットアップコピー処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected void setupCopy(Hashtable htbParam)
		throws LOException
	{


	}


	/**
	 * 安全にHashtableに追加するメソッドです
	 */
	private void putData( Hashtable htbData, String strValue, String strKey ) {
		if( strKey != null ) {
			htbData.put( strKey, strValue );
		}
	}

}
